]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
Merge branch 'jc/legacy-loose-object'
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
d27b876b 8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
9db31bdf 11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 13 or: $dashless [--quiet] foreach [--recursive] <command>
1d5bec8b 14 or: $dashless [--quiet] sync [--] [<path>...]"
8f321a39 15OPTIONS_SPEC=
70c7ac22 16. git-sh-setup
d0ad8251 17. git-sh-i18n
98fcf840 18. git-parse-remote
70c7ac22
LH
19require_work_tree
20
5c08dbbd 21command=
ecda0723 22branch=
d27b876b 23force=
d92a3959 24reference=
70c7ac22 25cached=
48bb3033
GP
26recursive=
27init=
1c244f6e 28files=
31ca3ac3 29nofetch=
32948425 30update=
15fc56a8 31prefix=
70c7ac22 32
f31a522a
ML
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
98fcf840 36 remote=$(get_default_remote)
8e7e6f39 37 remoteurl=$(git config "remote.$remote.url") ||
497ee872 38 die "$(eval_gettext "remote (\$remote) does not have a url defined in .git/config")"
f31a522a 39 url="$1"
99b120af 40 remoteurl=${remoteurl%/}
ea640cc6 41 sep=/
f31a522a
ML
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
ea640cc6
TR
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
497ee872 56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
ea640cc6
TR
57 ;;
58 esac
f31a522a
ML
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
ea640cc6 67 echo "$remoteurl$sep${url%/}"
f31a522a
ML
68}
69
a7b3269c
DA
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
313ee0d6
NMC
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
a7b3269c
DA
94}
95
941987a5
LH
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
537601ac 103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
fe22e542 104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
941987a5 107 test -z "$name" &&
497ee872 108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
941987a5
LH
109 echo "$name"
110}
33aa6fff
LH
111
112#
113# Clone a submodule
114#
23a485e3 115# Prior to calling, cmd_update checks that a possibly existing
ecda0723 116# path is not a git repository.
23a485e3 117# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
118# since it is the location of a new submodule.
119#
33aa6fff
LH
120module_clone()
121{
122 path=$1
123 url=$2
d92a3959 124 reference="$3"
33aa6fff 125
d92a3959
MT
126 if test -n "$reference"
127 then
128 git-clone "$reference" -n "$url" "$path"
129 else
130 git-clone -n "$url" "$path"
131 fi ||
497ee872 132 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
33aa6fff
LH
133}
134
ecda0723
SV
135#
136# Add a new submodule to the working tree, .gitmodules and the index
137#
ec05df35 138# $@ = repo path
ecda0723
SV
139#
140# optional branch is stored in global branch variable
141#
23a485e3 142cmd_add()
ecda0723 143{
5c08dbbd
JH
144 # parse $args after "submodule ... add".
145 while test $# -ne 0
146 do
147 case "$1" in
148 -b | --branch)
149 case "$2" in '') usage ;; esac
150 branch=$2
151 shift
152 ;;
d27b876b
JL
153 -f | --force)
154 force=$1
155 ;;
5c08dbbd 156 -q|--quiet)
2e6a30ef 157 GIT_QUIET=1
5c08dbbd 158 ;;
d92a3959
MT
159 --reference)
160 case "$2" in '') usage ;; esac
161 reference="--reference=$2"
162 shift
163 ;;
164 --reference=*)
165 reference="$1"
166 shift
167 ;;
5c08dbbd
JH
168 --)
169 shift
170 break
171 ;;
172 -*)
173 usage
174 ;;
175 *)
176 break
177 ;;
178 esac
179 shift
180 done
181
ecda0723
SV
182 repo=$1
183 path=$2
184
1414e578
JL
185 if test -z "$path"; then
186 path=$(echo "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
188 fi
189
ec05df35 190 if test -z "$repo" -o -z "$path"; then
ecda0723
SV
191 usage
192 fi
193
ec05df35
ML
194 # assure repo is absolute or relative to parent
195 case "$repo" in
196 ./*|../*)
197 # dereference source url relative to parent's url
198 realrepo=$(resolve_relative_url "$repo") || exit
199 ;;
200 *:*|/*)
201 # absolute url
202 realrepo=$repo
203 ;;
204 *)
497ee872 205 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
206 ;;
207 esac
208
db75ada5
MG
209 # normalize path:
210 # multiple //; leading ./; /./; /../; trailing /
211 path=$(printf '%s/\n' "$path" |
212 sed -e '
213 s|//*|/|g
214 s|^\(\./\)*||
215 s|/\./|/|g
216 :start
217 s|\([^/]*\)/\.\./||
218 tstart
219 s|/*$||
220 ')
5be60078 221 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
497ee872 222 die "$(eval_gettext "'\$path' already exists in the index")"
ecda0723 223
d27b876b
JL
224 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
225 then
3a4c3ed7
ÆAB
226 (
227 eval_gettext "The following path is ignored by one of your .gitignore files:
228\$path
229Use -f if you really want to add it." &&
230 echo
231 ) >&2
d27b876b
JL
232 exit 1
233 fi
234
d4264ca3
ML
235 # perhaps the path exists and is already a git repo, else clone it
236 if test -e "$path"
237 then
e9656473 238 if test -d "$path"/.git -o -f "$path"/.git
d4264ca3 239 then
dc2204fe 240 eval_gettext "Adding existing repo at '\$path' to the index"; echo
d4264ca3 241 else
497ee872 242 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
d4264ca3 243 fi
c2f93917
ML
244
245 case "$repo" in
246 ./*|../*)
247 url=$(resolve_relative_url "$repo") || exit
248 ;;
249 *)
250 url="$repo"
251 ;;
252 esac
253 git config submodule."$path".url "$url"
d4264ca3 254 else
d4264ca3 255
d92a3959 256 module_clone "$path" "$realrepo" "$reference" || exit
ea10b60c 257 (
74ae1419 258 clear_local_git_env
ea10b60c
BJ
259 cd "$path" &&
260 # ash fails to wordsplit ${branch:+-b "$branch"...}
261 case "$branch" in
262 '') git checkout -f -q ;;
502dc5b6 263 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 264 esac
497ee872 265 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
d4264ca3
ML
266 fi
267
d27b876b 268 git add $force "$path" ||
497ee872 269 die "$(eval_gettext "Failed to add submodule '\$path'")"
ecda0723 270
a5099bb4
IY
271 git config -f .gitmodules submodule."$path".path "$path" &&
272 git config -f .gitmodules submodule."$path".url "$repo" &&
31991b02 273 git add --force .gitmodules ||
497ee872 274 die "$(eval_gettext "Failed to register submodule '\$path'")"
ecda0723
SV
275}
276
19a31f9c
ML
277#
278# Execute an arbitrary command sequence in each checked out
279# submodule
280#
281# $@ = command to execute
282#
283cmd_foreach()
284{
1d5bec8b
JH
285 # parse $args after "submodule ... foreach".
286 while test $# -ne 0
287 do
288 case "$1" in
289 -q|--quiet)
290 GIT_QUIET=1
291 ;;
15fc56a8
JH
292 --recursive)
293 recursive=1
294 ;;
1d5bec8b
JH
295 -*)
296 usage
297 ;;
298 *)
299 break
300 ;;
301 esac
302 shift
303 done
304
f030c96d
ÆAB
305 toplevel=$(pwd)
306
a7b3269c 307 module_list |
19a31f9c
ML
308 while read mode sha1 stage path
309 do
310 if test -e "$path"/.git
311 then
490b6d57 312 say "$(eval_gettext "Entering '\$prefix\$path'")"
1e7f2aad 313 name=$(module_name "$path")
15fc56a8
JH
314 (
315 prefix="$prefix$path/"
74ae1419 316 clear_local_git_env
15fc56a8
JH
317 cd "$path" &&
318 eval "$@" &&
319 if test -n "$recursive"
320 then
321 cmd_foreach "--recursive" "$@"
322 fi
323 ) ||
497ee872 324 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
19a31f9c
ML
325 fi
326 done
327}
328
70c7ac22 329#
211b7f19 330# Register submodules in .git/config
70c7ac22
LH
331#
332# $@ = requested paths (default to all)
333#
23a485e3 334cmd_init()
70c7ac22 335{
5c08dbbd
JH
336 # parse $args after "submodule ... init".
337 while test $# -ne 0
338 do
339 case "$1" in
340 -q|--quiet)
2e6a30ef 341 GIT_QUIET=1
5c08dbbd
JH
342 ;;
343 --)
344 shift
345 break
346 ;;
347 -*)
348 usage
349 ;;
350 *)
351 break
352 ;;
353 esac
354 shift
355 done
356
a7b3269c 357 module_list "$@" |
70c7ac22
LH
358 while read mode sha1 stage path
359 do
211b7f19 360 # Skip already registered paths
941987a5 361 name=$(module_name "$path") || exit
5be60078 362 url=$(git config submodule."$name".url)
211b7f19 363 test -z "$url" || continue
70c7ac22 364
a5099bb4 365 url=$(git config -f .gitmodules submodule."$name".url)
70c7ac22 366 test -z "$url" &&
497ee872 367 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
70c7ac22 368
f31a522a
ML
369 # Possibly a url relative to parent
370 case "$url" in
371 ./*|../*)
8e7e6f39 372 url=$(resolve_relative_url "$url") || exit
f31a522a
ML
373 ;;
374 esac
375
5be60078 376 git config submodule."$name".url "$url" ||
497ee872 377 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
70c7ac22 378
32948425
JH
379 upd="$(git config -f .gitmodules submodule."$name".update)"
380 test -z "$upd" ||
381 git config submodule."$name".update "$upd" ||
497ee872 382 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
ca2cedba 383
497ee872 384 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
70c7ac22
LH
385 done
386}
387
388#
211b7f19 389# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
390#
391# $@ = requested paths (default to all)
392#
23a485e3 393cmd_update()
70c7ac22 394{
5c08dbbd 395 # parse $args after "submodule ... update".
98dbe63d 396 orig_flags=
5c08dbbd
JH
397 while test $# -ne 0
398 do
399 case "$1" in
400 -q|--quiet)
2e6a30ef 401 GIT_QUIET=1
5c08dbbd 402 ;;
be4d2c83 403 -i|--init)
d92a3959 404 init=1
be4d2c83 405 ;;
31ca3ac3 406 -N|--no-fetch)
31ca3ac3
FF
407 nofetch=1
408 ;;
9db31bdf
NMC
409 -f|--force)
410 force=$1
411 ;;
ca2cedba 412 -r|--rebase)
32948425 413 update="rebase"
ca2cedba 414 ;;
d92a3959
MT
415 --reference)
416 case "$2" in '') usage ;; esac
417 reference="--reference=$2"
98dbe63d
KB
418 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
419 shift
d92a3959
MT
420 ;;
421 --reference=*)
422 reference="$1"
d92a3959 423 ;;
42b49178 424 -m|--merge)
42b49178
JH
425 update="merge"
426 ;;
b13fd5c1 427 --recursive)
b13fd5c1
JH
428 recursive=1
429 ;;
5c08dbbd
JH
430 --)
431 shift
432 break
433 ;;
434 -*)
435 usage
436 ;;
437 *)
438 break
439 ;;
440 esac
98dbe63d
KB
441 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
442 shift
5c08dbbd
JH
443 done
444
d92a3959
MT
445 if test -n "$init"
446 then
447 cmd_init "--" "$@" || return
448 fi
449
1b4735d9 450 cloned_modules=
a7b3269c 451 module_list "$@" |
70c7ac22
LH
452 while read mode sha1 stage path
453 do
313ee0d6
NMC
454 if test "$stage" = U
455 then
456 echo >&2 "Skipping unmerged submodule $path"
457 continue
458 fi
941987a5 459 name=$(module_name "$path") || exit
5be60078 460 url=$(git config submodule."$name".url)
32948425 461 update_module=$(git config submodule."$name".update)
211b7f19 462 if test -z "$url"
70c7ac22
LH
463 then
464 # Only mention uninitialized submodules when its
465 # path have been specified
466 test "$#" != "0" &&
1c2ef66f
ÆAB
467 say "$(eval_gettext "Submodule path '\$path' not initialized
468Maybe you want to use 'update --init'?")"
211b7f19
LH
469 continue
470 fi
471
ba88a1fe 472 if ! test -d "$path"/.git -o -f "$path"/.git
211b7f19 473 then
d92a3959 474 module_clone "$path" "$url" "$reference"|| exit
1b4735d9 475 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
476 subsha1=
477 else
74ae1419 478 subsha1=$(clear_local_git_env; cd "$path" &&
5be60078 479 git rev-parse --verify HEAD) ||
497ee872 480 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
70c7ac22 481 fi
211b7f19 482
32948425 483 if ! test -z "$update"
ca2cedba 484 then
32948425 485 update_module=$update
ca2cedba
PH
486 fi
487
70c7ac22
LH
488 if test "$subsha1" != "$sha1"
489 then
9db31bdf
NMC
490 subforce=$force
491 # If we don't already have a -f flag and the submodule has never been checked out
492 if test -z "$subsha1" -a -z "$force"
b9b378a0 493 then
9db31bdf 494 subforce="-f"
b9b378a0 495 fi
31ca3ac3
FF
496
497 if test -z "$nofetch"
498 then
e5f522d6
JL
499 # Run fetch only if $sha1 isn't present or it
500 # is not reachable from a ref.
74ae1419 501 (clear_local_git_env; cd "$path" &&
f5799e05 502 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 503 test -z "$rev") || git-fetch)) ||
497ee872 504 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
31ca3ac3
FF
505 fi
506
1b4735d9
SO
507 # Is this something we just cloned?
508 case ";$cloned_modules;" in
509 *";$name;"*)
510 # then there is no local change to integrate
511 update_module= ;;
512 esac
513
32948425
JH
514 case "$update_module" in
515 rebase)
516 command="git rebase"
ee653c89
ÆAB
517 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
518 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
32948425 519 ;;
42b49178
JH
520 merge)
521 command="git merge"
ee653c89
ÆAB
522 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
523 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
42b49178 524 ;;
32948425 525 *)
9db31bdf 526 command="git checkout $subforce -q"
ee653c89
ÆAB
527 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
528 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
32948425
JH
529 ;;
530 esac
70c7ac22 531
ee653c89
ÆAB
532 (clear_local_git_env; cd "$path" && $command "$sha1") || die $die_msg
533 say $say_msg
70c7ac22 534 fi
b13fd5c1
JH
535
536 if test -n "$recursive"
537 then
98dbe63d 538 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
497ee872 539 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
b13fd5c1 540 fi
70c7ac22
LH
541 done
542}
543
bffe71f4
EM
544set_name_rev () {
545 revname=$( (
74ae1419 546 clear_local_git_env
bffe71f4 547 cd "$1" && {
5be60078
JH
548 git describe "$2" 2>/dev/null ||
549 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
550 git describe --contains "$2" 2>/dev/null ||
551 git describe --all --always "$2"
bffe71f4
EM
552 }
553 ) )
554 test -z "$revname" || revname=" ($revname)"
555}
28f9af5d
PY
556#
557# Show commit summary for submodules in index or working tree
558#
559# If '--cached' is given, show summary between index and given commit,
560# or between working tree and given commit
561#
562# $@ = [commit (default 'HEAD'),] requested paths (default all)
563#
564cmd_summary() {
f2dc06a3 565 summary_limit=-1
d0f64dd4 566 for_status=
1c244f6e 567 diff_cmd=diff-index
f2dc06a3 568
28f9af5d
PY
569 # parse $args after "submodule ... summary".
570 while test $# -ne 0
571 do
572 case "$1" in
573 --cached)
574 cached="$1"
575 ;;
1c244f6e
JL
576 --files)
577 files="$1"
578 ;;
d0f64dd4
PY
579 --for-status)
580 for_status="$1"
581 ;;
f2dc06a3
PY
582 -n|--summary-limit)
583 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
584 then
585 :
586 else
587 usage
588 fi
589 shift
590 ;;
28f9af5d
PY
591 --)
592 shift
593 break
594 ;;
595 -*)
596 usage
597 ;;
598 *)
599 break
600 ;;
601 esac
602 shift
603 done
bffe71f4 604
f2dc06a3
PY
605 test $summary_limit = 0 && return
606
3deea89c 607 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
608 then
609 head=$rev
caa9c3ca 610 test $# = 0 || shift
3deea89c
JH
611 elif test -z "$1" -o "$1" = "HEAD"
612 then
14e940d7
JH
613 # before the first commit: compare with an empty tree
614 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 615 test -z "$1" || shift
28f9af5d 616 else
3deea89c 617 head="HEAD"
28f9af5d
PY
618 fi
619
1c244f6e
JL
620 if [ -n "$files" ]
621 then
622 test -n "$cached" &&
b9b9c22f 623 die "$(gettext -- "--cached cannot be used with --files")"
1c244f6e
JL
624 diff_cmd=diff-files
625 head=
626 fi
627
28f9af5d
PY
628 cd_to_toplevel
629 # Get modified modules cared by user
18076502 630 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 631 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
632 while read mod_src mod_dst sha1_src sha1_dst status name
633 do
634 # Always show modules deleted or type-changed (blob<->module)
635 test $status = D -o $status = T && echo "$name" && continue
636 # Also show added or modified modules which are checked out
637 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
638 echo "$name"
639 done
640 )
1cb639e6 641
d0f64dd4
PY
642 test -z "$modules" && return
643
18076502 644 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 645 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
646 cut -c2- |
647 while read mod_src mod_dst sha1_src sha1_dst status name
648 do
649 if test -z "$cached" &&
650 test $sha1_dst = 0000000000000000000000000000000000000000
651 then
652 case "$mod_dst" in
653 160000)
654 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
655 ;;
656 100644 | 100755 | 120000)
657 sha1_dst=$(git hash-object $name)
658 ;;
659 000000)
660 ;; # removed
661 *)
662 # unexpected type
dc2204fe
ÆAB
663 (
664 eval_gettext "unexpected mode \$mod_dst" &&
665 echo
666 ) >&2
1cb639e6
PY
667 continue ;;
668 esac
669 fi
670 missing_src=
671 missing_dst=
672
673 test $mod_src = 160000 &&
30353a40 674 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
675 missing_src=t
676
677 test $mod_dst = 160000 &&
30353a40 678 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 679 missing_dst=t
bffe71f4 680
1cb639e6
PY
681 total_commits=
682 case "$missing_src,$missing_dst" in
683 t,)
f62f8212 684 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
1cb639e6
PY
685 ;;
686 ,t)
f62f8212 687 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
688 ;;
689 t,t)
f62f8212 690 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
691 ;;
692 *)
693 errmsg=
694 total_commits=$(
695 if test $mod_src = 160000 -a $mod_dst = 160000
696 then
697 range="$sha1_src...$sha1_dst"
698 elif test $mod_src = 160000
699 then
700 range=$sha1_src
701 else
702 range=$sha1_dst
703 fi
704 GIT_DIR="$name/.git" \
b0e621ad 705 git rev-list --first-parent $range -- | wc -l
1cb639e6 706 )
eed35595 707 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
708 ;;
709 esac
710
711 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
712 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
713 if test $status = T
714 then
b3e73449
ÆAB
715 blob="$(gettext "blob")"
716 submodule="$(gettext "submodule")"
1cb639e6
PY
717 if test $mod_dst = 160000
718 then
b3e73449 719 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 720 else
b3e73449 721 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
722 fi
723 else
724 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
725 fi
726 if test -n "$errmsg"
727 then
728 # Don't give error msg for modification whose dst is not submodule
729 # i.e. deleted or changed to blob
730 test $mod_dst = 160000 && echo "$errmsg"
731 else
732 if test $mod_src = 160000 -a $mod_dst = 160000
733 then
f2dc06a3
PY
734 limit=
735 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 736 GIT_DIR="$name/.git" \
f2dc06a3 737 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
738 --first-parent $sha1_src...$sha1_dst
739 elif test $mod_dst = 160000
740 then
741 GIT_DIR="$name/.git" \
742 git log --pretty='format: > %s' -1 $sha1_dst
743 else
744 GIT_DIR="$name/.git" \
745 git log --pretty='format: < %s' -1 $sha1_src
746 fi
747 echo
748 fi
749 echo
d0f64dd4
PY
750 done |
751 if test -n "$for_status"; then
f17a5d34 752 if [ -n "$files" ]; then
165119e9 753 gettext "# Submodules changed but not updated:"; echo
f17a5d34 754 else
165119e9 755 gettext "# Submodule changes to be committed:"; echo
f17a5d34 756 fi
d0f64dd4
PY
757 echo "#"
758 sed -e 's|^|# |' -e 's|^# $|#|'
759 else
760 cat
761 fi
28f9af5d 762}
70c7ac22 763#
941987a5 764# List all submodules, prefixed with:
70c7ac22
LH
765# - submodule not initialized
766# + different revision checked out
767#
768# If --cached was specified the revision in the index will be printed
769# instead of the currently checked out revision.
770#
771# $@ = requested paths (default to all)
772#
23a485e3 773cmd_status()
70c7ac22 774{
5c08dbbd 775 # parse $args after "submodule ... status".
98dbe63d 776 orig_flags=
5c08dbbd
JH
777 while test $# -ne 0
778 do
779 case "$1" in
780 -q|--quiet)
2e6a30ef 781 GIT_QUIET=1
5c08dbbd
JH
782 ;;
783 --cached)
784 cached=1
785 ;;
64b19ffe
JH
786 --recursive)
787 recursive=1
788 ;;
5c08dbbd
JH
789 --)
790 shift
791 break
792 ;;
793 -*)
794 usage
795 ;;
796 *)
797 break
798 ;;
799 esac
98dbe63d 800 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
5c08dbbd
JH
801 shift
802 done
803
a7b3269c 804 module_list "$@" |
70c7ac22
LH
805 while read mode sha1 stage path
806 do
941987a5 807 name=$(module_name "$path") || exit
5be60078 808 url=$(git config submodule."$name".url)
64b19ffe 809 displaypath="$prefix$path"
313ee0d6
NMC
810 if test "$stage" = U
811 then
812 say "U$sha1 $displaypath"
813 continue
814 fi
ba88a1fe 815 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
70c7ac22 816 then
64b19ffe 817 say "-$sha1 $displaypath"
70c7ac22
LH
818 continue;
819 fi
41c7c1bd 820 set_name_rev "$path" "$sha1"
18076502 821 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
70c7ac22 822 then
64b19ffe 823 say " $sha1 $displaypath$revname"
70c7ac22
LH
824 else
825 if test -z "$cached"
826 then
74ae1419 827 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
41c7c1bd 828 set_name_rev "$path" "$sha1"
70c7ac22 829 fi
64b19ffe
JH
830 say "+$sha1 $displaypath$revname"
831 fi
832
833 if test -n "$recursive"
834 then
835 (
836 prefix="$displaypath/"
74ae1419 837 clear_local_git_env
64b19ffe 838 cd "$path" &&
a7eff1a8 839 eval cmd_status "$orig_args"
64b19ffe 840 ) ||
497ee872 841 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
70c7ac22
LH
842 fi
843 done
844}
2327f61e
DA
845#
846# Sync remote urls for submodules
847# This makes the value for remote.$remote.url match the value
848# specified in .gitmodules.
849#
850cmd_sync()
851{
852 while test $# -ne 0
853 do
854 case "$1" in
855 -q|--quiet)
2e6a30ef 856 GIT_QUIET=1
2327f61e
DA
857 shift
858 ;;
859 --)
860 shift
861 break
862 ;;
863 -*)
864 usage
865 ;;
866 *)
867 break
868 ;;
869 esac
870 done
871 cd_to_toplevel
872 module_list "$@" |
873 while read mode sha1 stage path
874 do
875 name=$(module_name "$path")
876 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
877
878 # Possibly a url relative to parent
879 case "$url" in
880 ./*|../*)
881 url=$(resolve_relative_url "$url") || exit
882 ;;
883 esac
884
8f3f2c44 885 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
33f072f8
AK
886 git config submodule."$name".url "$url"
887
2327f61e
DA
888 if test -e "$path"/.git
889 then
890 (
74ae1419 891 clear_local_git_env
2327f61e
DA
892 cd "$path"
893 remote=$(get_default_remote)
2327f61e
DA
894 git config remote."$remote".url "$url"
895 )
896 fi
897 done
898}
70c7ac22 899
5c08dbbd
JH
900# This loop parses the command line arguments to find the
901# subcommand name to dispatch. Parsing of the subcommand specific
902# options are primarily done by the subcommand implementations.
903# Subcommand specific options such as --branch and --cached are
904# parsed here as well, for backward compatibility.
905
906while test $# != 0 && test -z "$command"
70c7ac22
LH
907do
908 case "$1" in
2327f61e 909 add | foreach | init | update | status | summary | sync)
5c08dbbd 910 command=$1
70c7ac22
LH
911 ;;
912 -q|--quiet)
2e6a30ef 913 GIT_QUIET=1
70c7ac22 914 ;;
ecda0723
SV
915 -b|--branch)
916 case "$2" in
917 '')
918 usage
919 ;;
920 esac
921 branch="$2"; shift
922 ;;
70c7ac22 923 --cached)
28f9af5d 924 cached="$1"
70c7ac22
LH
925 ;;
926 --)
927 break
928 ;;
929 -*)
930 usage
931 ;;
932 *)
933 break
934 ;;
935 esac
936 shift
937done
938
5c08dbbd
JH
939# No command word defaults to "status"
940test -n "$command" || command=status
941
942# "-b branch" is accepted only by "add"
943if test -n "$branch" && test "$command" != add
944then
ecda0723 945 usage
5c08dbbd
JH
946fi
947
28f9af5d
PY
948# "--cached" is accepted only by "status" and "summary"
949if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 950then
70c7ac22 951 usage
5c08dbbd
JH
952fi
953
954"cmd_$command" "$@"